<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/12/2004 *
 * ================                             Last change: 02/27/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-del_email.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Delete a bonus or normal mail                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bonus- / Normal-Mail loeschen                    *
 * -------------------------------------------------------------------- *
 *                                                                      *
 *  Module by Robert Niedziela, Megacomputing                           *
 *          web : http://mc-p.mcserver.de                               *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

// Init counter for deleted mails
$cnt = 0;

if (REQUEST_ISSET_GET(('mid'))) {
	// Load email data
	$result = SQL_QUERY_ESC("SELECT id, sender, subject, url, timestamp, payment_id FROM `{!_MYSQL_PREFIX!}_pool` WHERE `id`=%s LIMIT 1",
		array(bigintval(REQUEST_GET('mid'))), __FILE__, __LINE__);

	// Delete mail only once
	if (SQL_NUMROWS($result) == 1) {
		// Load data
		list ($id, $sender, $subject, $url, $timestamp, $payId) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Get points we shall pay back per mail
		$price = getPaymentPoints($payId, 'price');

		// Prepare data for the template
		define('__ID'     , $id);
		define('__SENDER' , generateUserProfileLink($sender));
		define('__SUBJECT', $subject);
		define('__URL'    , DEREFERER($url));
		define('__ORDERED', generateDateTime($timestamp, '0'));

		// Load template
		LOAD_TEMPLATE("admin_del_email_normal");

		// Transfer data to data array
		$DATA = array('url' => $url, 'subject' => $subject);

		// Load email template and send the email away
		$msg_user = LOAD_EMAIL_TEMPLATE("order-deleted", array(), $sender);
		sendEmail($sender, getMessage('MEMBER_ORDER_DELETED'), $msg_user);

		// Fetch right stats_id from pool
		$result_pool = SQL_QUERY_ESC("SELECT s.id FROM `{!_MYSQL_PREFIX!}_user_stats` AS s
LEFT JOIN `{!_MYSQL_PREFIX!}_pool` AS p
ON s.pool_id=p.id
WHERE s.pool_id=%s LIMIT 1",
 array(bigintval(REQUEST_GET('mid'))), __FILE__, __LINE__);
		if (SQL_NUMROWS($result_pool) == 1) {
			// Fetch stats id
			list($stats_id) = SQL_FETCHROW($result_pool);

			// Get all user links
			$links = GET_TOTAL_DATA($stats_id, "user_links", 'userid', "stats_id", true);

			// Reset sent mails for recipient(s)
			reduceRecipientReceivedMails("stats_id", REQUEST_GET('mid'), $links);

			// Calc total points and pay them back
			$totalPoints = $links * $price;

			// Shall we pay the points back to the user?
			if (getConfig('repay_deleted_mails') != 'SHRED') {
				//* DEBUG: */ echo $stats_id.':'.$totalPoints.'/'.$links.'/'.$price."<br />\n";
				if ($totalPoints > 0) {
					// Shall we payback to user or jackpot?
					if (getConfig('repay_deleted_mails') == 'JACKPOT') {
						// Set jackpot
						$sender = 0;
					} // END - if

					// Pay back points
					//* DEBUG: */ echo "PAYBACK:".$sender."<br />\n";
					ADD_POINTS_REFSYSTEM('mail_deleted', $sender, $totalPoints, true, '0', false,'direct');

					// Output message
					if (getConfig('repay_deleted_mails') == 'REPAY') {
						// Repayed
						LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('ADMIN_POINTS_REPAYED'),
							translateComma($totalPoints)
						));
					} else {
						// To jackpot
						LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('ADMIN_POINTS_TO_JACKPOT'),
							translateComma($totalPoints)
						));
					}
				} else {
					// No points repayed!
					LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_NO_POINTS_REPAYED'));
				}
			} else {
				// Points shredded!
				LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('ADMIN_POINTS_SHREDDED'), $totalPoints));
			}

			// Remove links from DB
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_user_links` WHERE stats_id=%s",
				array(bigintval($stats_id)), __FILE__, __LINE__);
			$cnt += SQL_AFFECTEDROWS();

			// Load template for link
			LOAD_TEMPLATE('admin_settings_saved', false, "<a href=\"{!URL!}/modules.php?module=admin&amp;what=del_email&amp;pid=".bigintval(REQUEST_GET('mid'))."\">".ADMIN_REMOVE_STATS_ENTRY."</a>");
		} // END - if

		// Free the result
		SQL_FREERESULT($result_pool);

		// Delete mail from queue
		SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_pool` WHERE `id`=%s LIMIT 1",
			array(bigintval(REQUEST_GET('mid'))), __FILE__, __LINE__);
		$cnt += SQL_AFFECTEDROWS();

		// Output link for manually removing stats entry
		OUTPUT_HTML(sprintf(ADMIN_DELETED_MAILS_COUNT, $cnt));
	} else {
		// Mail already deleted!
		LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_NORMAL_MAIL_ALREADY_DELETED'));
	}
} elseif (REQUEST_ISSET_GET(('pid'))) {
	// Remove stats entries
	SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_user_stats` WHERE pool_id=%s LIMIT 1",
		array(bigintval(REQUEST_GET('pid'))), __FILE__, __LINE__);

	// Output message
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_USER_STATS_REMOVED'));
} elseif ((REQUEST_ISSET_GET(('bid'))) && (EXT_IS_ACTIVE('bonus'))) {
	// Load data from bonus mail
	$result = SQL_QUERY_ESC("SELECT id, subject, url, timestamp, mails_sent FROM `{!_MYSQL_PREFIX!}_bonus` WHERE `id`=%s",
		array(bigintval(REQUEST_GET('bid'))), __FILE__, __LINE__);

	// Delete mail only once
	if (SQL_NUMROWS($result) == 1) {
		// Load data
		list ($id, $subject, $url, $timestamp, $sent) = SQL_FETCHROW($result);

		// Reset sent mails for recipient(s)
		reduceRecipientReceivedMails('bonus_id', REQUEST_GET('bid'), $sent);

		// Init counter for deleted mails
		$cnt = 0;

		// Delete bonus mail entirely from database
		SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_bonus` WHERE `id`=%s LIMIT 1",
			array(bigintval(REQUEST_GET('bid'))), __FILE__, __LINE__);
		$cnt += SQL_AFFECTEDROWS();
		SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_user_links` WHERE bonus_id=%s",
			array(bigintval(REQUEST_GET('bid'))), __FILE__, __LINE__);
		$cnt += SQL_AFFECTEDROWS();

		// Prepare data for the template
		define('__ID'     , $id);
		define('__SUBJECT', $subject);
		define('__URL'    , DEREFERER($url));
		define('__ORDERED', generateDateTime($timestamp, '0'));
		define('__CNT'    , $cnt);

		// Load template
		LOAD_TEMPLATE("admin_del_email_bonus");
	} else {
		// Mail already deleted!
		LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_BONUS_MAIL_ALREADY_DELETED'));
	}

	// Free result
	SQL_FREERESULT($result);
} elseif ((REQUEST_ISSET_GET(('nid'))) && (GET_EXT_VERSION('bonus') >= '0.8.7')) {
	// Load data from bonus mail
	$result = SQL_QUERY_ESC("SELECT id, subject, url, timestamp FROM `{!_MYSQL_PREFIX!}_bonus` WHERE `id`=%s",
		array(bigintval(REQUEST_GET('nid'))), __FILE__, __LINE__);

	// Delete mail only once
	if (SQL_NUMROWS($result) == 1) {
		// Load data
		list ($id, $subject, $url, $timestamp) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Init counter for deleted mails
		$cnt = 0;

		// Delete bonus mail entirely from database
		SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_bonus` WHERE `id`=%s LIMIT 1",
			array(bigintval(REQUEST_GET('nid'))), __FILE__, __LINE__);
		$cnt += SQL_AFFECTEDROWS();
		SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_user_links` WHERE bonus_id=%s",
			array(bigintval(REQUEST_GET('nid'))), __FILE__, __LINE__);
		$cnt += SQL_AFFECTEDROWS();

		// Prepare data for the template
		define('__ID'     , $id);
		define('__SUBJECT', $subject);
		define('__URL'    , DEREFERER($url));
		define('__ORDERED', generateDateTime($timestamp, '0'));
		define('__CNT'    , $cnt);

		// Load template
		LOAD_TEMPLATE("admin_del_email_notify");
	} else {
		// Mail already deleted!
		LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_NOTIFY_MAIL_ALREADY_DELETED'));
	}
} else {
	// No mail orders fond
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_WRONG_CALL'));
}

//
?>
