<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/26/2004 *
 * ================                             Last change: 06/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_autopurge.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Find inactive accounts and just list them        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Inaktive Accounts finden und dann auflisten      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

// Exclude default referal id if set
$EXCLUDE_LIST = '';
if (getConfig('def_refid') > 0) {
	$EXCLUDE_LIST = " AND d.userid != ".getConfig('def_refid')."";
} // END - if

// Check for more extensions
// @TODO Rewrite those lines to filter
if (EXT_IS_ACTIVE('beg'))                  $EXCLUDE_LIST .= " AND d.userid != ".getConfig('beg_uid')."";
if (EXT_IS_ACTIVE('bonus'))                $EXCLUDE_LIST .= " AND d.userid != ".getConfig('bonus_uid')."";
if (EXT_IS_ACTIVE('doubler'))              $EXCLUDE_LIST .= " AND d.userid != ".getConfig('doubler_uid')."";
if (GET_EXT_VERSION('holiday') >= '0.1.3') $EXCLUDE_LIST .= " AND d.`holiday_active`='N'";

// Check for all accounts
$result = SQL_QUERY_ESC("SELECT DISTINCT d.userid, d.gender, d.surname, d.family, d.email, d.joined, d.last_online, d.ap_notified
FROM `{!_MYSQL_PREFIX!}_user_data` AS d
WHERE d.`status`='CONFIRMED' AND d.joined < (UNIX_TIMESTAMP() - %s) AND d.last_online < (UNIX_TIMESTAMP() - %s) AND d.ap_notified < (UNIX_TIMESTAMP() - %s)
".$EXCLUDE_LIST."
ORDER BY d.userid",
	array(
		getConfig('ap_inactive_since'),
		getConfig('ap_inactive_since'),
		getConfig('ap_inactive_since')
	), __FILE__, __LINE__);

if (SQL_NUMROWS($result) > 0) {
	// Ok, we have found some inactive accounts
	$OUT = ''; $SW = 2;
	while ($content = SQL_FETCHARRAY($result)) {
		// Prepare data for the row template
		// @TODO Rewritings: sname->surname,fname->family in templates
		$content = array(
			'sw'       => $SW,
			'uid'      => generateUserProfileLink($content['userid']),
			'gender'   => translateGender($content['gender']),
			'sname'    => $content['surname'],
			'fname'    => $content['family'],
			'email'    => "<a href=\"".generateMemberEmailLink($content['email'], "user_data")."\">".$content['email']."</a>",
			'joined'   => generateDateTime($content['joined'], "2"),
			'last'     => generateDateTime($content['last_online'], "2"),
			'notified' => generateDateTime($content['ap_notified'], "2"),
		);

		// Load row template
		$OUT .= LOAD_TEMPLATE("admin_list_autopurge_row", true, $content);
		$SW = 3 - $SW;
	}

	// Free memory
	SQL_FREERESULT($result);
	// @TODO Rewrite this constant
	define('__AUTOPURGE_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_list_autopurge");
} else {
	// All members are active or you don't have any registered
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_AUTOPURGE_ALL_ACTIVE'));
}

//
?>
