<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/12/2004 *
 * ================                             Last change: 09/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-optimize.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Optimize and repair database                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Datenbank optimieren und reparieren              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

// Optimize and repair database and return the result as a multi-dimensional array
$DATA = REPAIR_OPTIMIZE_DB();

// Output rows
$SW = 2; $gain_tabs = 0; $OUT = '';
foreach ($DATA['tables'] as $row_array)
{
	// Init variables
	$B1 = ''; $B2 = '';

	// Fixes a bug which causes a parser error on eval'd code
	if (empty($row_array[1])) $row_array[1] = "NONE";

	// Get optimization status
	$REP = constant('OPTIMIZE_STATUS_'.strtoupper($row_array[1]).'');

	$OPT = OPTIMIZE_STATUS_UNSUPPORTED;

	if ($row_array[4] > 0) {
		$OPT = OPTIMIZE_STATUS_OPTIMIZED;
		$B1 = "<strong>"; $B2 = "<strong>";
		$gain_tabs++;
	} elseif (count(explode(" ", $row_array[2])) == 0) {
		$OPT = constant('OPTIMIZE_STATUS_'.strtoupper($row_array[2]).'');
	}

	// Prepare data for the row template
	$content = array(
		'sw'  => $SW,
		'b1'  => $B1,
		'b2'  => $B2,
		'tpl' => $row_array[0],
		'rep' => $REP,
		'opt' => $OPT,
		'sum' => translateComma($row_array[3]),
		'sav' => translateComma($row_array[4]),
	);

	// Load row template and switch color
	$OUT .= LOAD_TEMPLATE("admin_optimize_row", true, $content);
	$SW = 3 - $SW;
}
define('__ROWS', $OUT);

// Prepare data for the template
define('__TOTAL_TABS'     , $DATA['total_tabs']);
define('__TOTAL_SIZE'     , translateComma($DATA['total_size']));
define('__TOTAL_CALLS'    , $DATA['total_rows']);
define('__TOTAL_OPTIMIZED', translateComma($DATA['total_opti']));
define('__NOW_OPTIMIZED'  , $gain_tabs);
define('__NOW_SAVED'      , translateComma($DATA['total_gain']));

// Load main template
LOAD_TEMPLATE("admin_optimize");

//
?>
