<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/24/2004 *
 * ================                             Last change: 07/31/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-holiday.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Holiday requests                                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Urlaubsschaltungen                               *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif (!IS_MEMBER()) {
	redirectToUrl('modules.php?module=index');
} elseif ((!EXT_IS_ACTIVE('holiday')) && (!IS_ADMIN())) {
	addFatalMessage(__FILE__, __LINE__, sprintf(getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), 'holiday'));
	return;
}

// Add description as navigation point
ADD_DESCR('member', __FILE__);

// Check for running mail orders in pool
$result1 = SQL_QUERY_ESC("SELECT timestamp FROM `{!_MYSQL_PREFIX!}_pool`
WHERE sender=%s ORDER BY timestamp DESC LIMIT 1", array(getUserId()), __FILE__, __LINE__);

// Check for sent mail orders in stats
$result2 = SQL_QUERY_ESC("SELECT timestamp_ordered FROM `{!_MYSQL_PREFIX!}_user_stats`
WHERE userid=%s ORDER BY timestamp_ordered DESC LIMIT 1", array(getUserId()), __FILE__, __LINE__);

if ((SQL_NUMROWS($result1) == 1) || (SQL_NUMROWS($result2) == 1)) {
	// Mail order found!
	list($stamp1) = SQL_FETCHROW($result1);
	list($stamp2) = SQL_FETCHROW($result2);
	if (empty($stamp1)) $stamp1 = 0;
	if (empty($stamp2)) $stamp2 = 0;

	if ((($stamp1 + getConfig('holiday_lock')) > time()) || (($stamp2 + getConfig('holiday_lock')) > time())) {
		// Mail order is to close away!
		REQUEST_UNSET_POST('ok');
		REQUEST_UNSET_POST('stop');

		if (($stamp1 + getConfig('holiday_lock')) > time()) {
			// Mail found in pool
			$stamp = $stamp1;
		} else {
			// Mail found in stats
			$stamp = $stamp2;
		}

		// Display message and exit here
		LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('HOLIDAY_MEMBER_ORDER'), generateDateTime($stamp, '1')));
		return;
	}
}

// Free memory
SQL_FREERESULT($result1);
SQL_FREERESULT($result2);

if (IS_FORM_SENT()) {
	// Check holiday request...
	$START = mktime(0, 0, 0, REQUEST_POST('start_month'), REQUEST_POST('start_day'), REQUEST_POST('start_year'));
	$END   = mktime(0, 0, 0, REQUEST_POST('end_month')  , REQUEST_POST('end_day')  , REQUEST_POST('end_year')  );

	// Test both values
	$TEST = $END - $START;
	if (($TEST < 0) || ($TEST > (getConfig('one_day') * getConfig('holiday_max'))) || ($START < time()) || ($END < time())) {
		// Time test failed
		REQUEST_UNSET_POST('ok');
	} else {
		// Everything went okay so let's store his request and send mails
		SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_user_holidays` (userid, holiday_start, holiday_end, comments) VALUES ('%s','%s','%s','%s')",
		 array(getUserId(), $START, $END, REQUEST_POST('comments')), __FILE__, __LINE__);

		// Activate holiday system
		SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data`
SET `holiday_active`='N', holiday_activated=UNIX_TIMESTAMP()
WHERE userid=%s LIMIT 1",
		 array(getUserId()), __FILE__, __LINE__);

		// Prepare constants
		define('_START_DAY'  , REQUEST_POST('start_day'));
		define('_START_MONTH', $GLOBALS['month_descr'][REQUEST_POST('start_month')]);
		define('_START_YEAR' , REQUEST_POST('start_year'));
		define('_END_DAY'    , REQUEST_POST('end_day'));
		define('_END_MONTH'  , $GLOBALS['month_descr'][REQUEST_POST('end_month')]);
		define('_END_YEAR'   , REQUEST_POST('end_year'));

		// Send mail to member
		$msg = LOAD_EMAIL_TEMPLATE('member_holiday_request', REQUEST_POST('comments'), getUserId());
		sendEmail(getUserId(), getMessage('HOLIDAY_MEMBER_SUBJECT'), $msg);

		// Send mail to all admins
		sendAdminNotification(getMessage('HOLIDAY_ADMIN_SUBJECT'), 'admin_holiday_request', REQUEST_POST('comments'), getUserId());

		// Create task
		SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_task_system` (userid, assigned_admin, status, task_type, subject, text, task_created) VALUES ('%s','0','NEW','HOLIDAY_REQUEST','{--HOLIDAY_ADMIN_SUBJECT--}','%s', UNIX_TIMESTAMP())",
			array(getUserId(), $msg), __FILE__, __LINE__);

		// Display message
		LOAD_TEMPLATE('admin_settings_saved', false, getMessage('HOLIDAY_IS_ACTIVATED_NOW'));
	}
}

// Holiday shall be ended now
if (REQUEST_ISSET_POST(('stop'))) {
	// Okay, end the holiday here...
	$result = SQL_QUERY_ESC("SELECT holiday_active, holiday_activated FROM `{!_MYSQL_PREFIX!}_user_data`
WHERE userid=%s LIMIT 1", array(getUserId()), __FILE__, __LINE__);
	list($active, $locked) = SQL_FETCHROW($result);
	SQL_FREERESULT($result);

	if (($active == 'Y') && (($locked + getConfig('holiday_lock')) < time())) {
		// Load data
		$result = SQL_QUERY_ESC("SELECT holiday_start, holiday_end FROM `{!_MYSQL_PREFIX!}_user_holidays`
WHERE userid=%s LIMIT 1", array(getUserId()), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Data was found
			list($start, $end) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Prepare it for the template
			define('__HOLIDAY_START', generateDateTime($start, "3"));
			define('__HOLIDAY_END'  , generateDateTime($end  , "3"));

			// Deactivate it now
			SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data`
SET `holiday_active`='N', holiday_activated='0'
WHERE userid=%s LIMIT 1", array(getUserId()), __FILE__, __LINE__);

			// Remove entry
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_user_holidays`
WHERE userid=%s LIMIT 1", array(getUserId()), __FILE__, __LINE__);

			// Send email to admin
			sendAdminNotification(getMessage('HOLIDAY_ADMIN_DEAC_SUBJ'), 'admin_holiday_deactivated', array(), getUserId());

			// Display message to user
			LOAD_TEMPLATE('admin_settings_saved', false, getMessage('HOLIDAY_MEMBER_DEACTIVATED_NOW'));
		} else {
			// Display message to user
			LOAD_TEMPLATE('admin_settings_saved', false, getMessage('HOLIDAY_MEMBER_CANNOT_DEACTIVATE'));
		}
	} elseif ($active == 'Y') {
		// To fast!
		LOAD_TEMPLATE('admin_settings_saved', false, getMessage('HOLIDAY_MEMBER_LOCKED'));
	}
}

// If something is wrong or link in menu is just clicked display form
if ((!IS_FORM_SENT()) && (!REQUEST_ISSET_POST(('stop'))) {
	// Check if user is in holiday...
	$result = SQL_QUERY_ESC("SELECT holiday_active, holiday_activated FROM `{!_MYSQL_PREFIX!}_user_data`
WHERE userid=%s LIMIT 1", array(getUserId()), __FILE__, __LINE__);
	list($active, $locked) = SQL_FETCHROW($result);
	SQL_FREERESULT($result);

	// Check for lock
	if (($locked + getConfig('holiday_lock')) < time()) {
		// User can deactivate his holiday request
		switch ($active)
		{
		case 'Y': // Display deactivation form
			// Load starting and ending date
			$result = SQL_QUERY_ESC("SELECT holiday_start, holiday_end FROM `{!_MYSQL_PREFIX!}_user_holidays`
WHERE userid=%s LIMIT 1", array(getUserId()), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Data was found
				list($start, $end) = SQL_FETCHROW($result);
				SQL_FREERESULT($result);

				// Prepare it for the template
				define('__HOLIDAY_START', generateDateTime($start , '3'));
				define('__HOLIDAY_END'  , generateDateTime($end   , '3'));
				define('__HOLIDAY_LOCK' , generateDateTime($locked, '1'));

				// Load template
				LOAD_TEMPLATE('member_holiday_deactivate');
			} else {
				// Free memory
				SQL_FREERESULT($result);

				// Remove entry and reload URL
				SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data`
SET `holiday_active`='N'
WHERE userid=%s LIMIT 1", array(getUserId()), __FILE__, __LINE__);
				redirectToUrl('modules.php?module=login&amp;what=holiday');
				return;
			}
			break;

		case 'N': // Display activation form
			// Starting day
			define('_START_DAY'  , ADD_SELECTION('day'  , date('d', (time() + getConfig('one_day'))), 'start'));
			define('_START_MONTH', ADD_SELECTION('month', date('m', (time() + getConfig('one_day'))), 'start'));
			define('_START_YEAR' , ADD_SELECTION('year' , date('Y', (time() + getConfig('one_day'))), 'start'));

			// Calcualte ending date
			$D = date('d', time() + getConfig('one_day') + (getConfig('one_day') * getConfig('holiday_max')));
			$M = date('m', time() + getConfig('one_day') + (getConfig('one_day') * getConfig('holiday_max')));
			$Y = date('Y', time() + getConfig('one_day') + (getConfig('one_day') * getConfig('holiday_max')));

			// Ending day
			define('_END_DAY'  , ADD_SELECTION('day'  , $D, 'end'));
			define('_END_MONTH', ADD_SELECTION('month', $M, 'end'));
			define('_END_YEAR' , ADD_SELECTION('year' , $Y, 'end'));

			// Copy value from configuration
			define('__HOLIDAY_MAX', getConfig('holiday_max'));

			// Output form
			LOAD_TEMPLATE('member_holiday_form');
			break;
		}
	} else {
		// To fast!
		LOAD_TEMPLATE('admin_settings_saved', false, getMessage('HOLIDAY_MEMBER_LOCKED'));
	}
}
//
?>
