<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/19/2003 *
 * ===============                              Last change: 08/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-order.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Order mails here                                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Hier koennen Ihre Mitglieder Mails buchen        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif (!IS_MEMBER()) {
	redirectToUrl('modules.php?module=index');
} elseif ((!EXT_IS_ACTIVE('order')) && (!IS_ADMIN())) {
	addFatalMessage(__FILE__, __LINE__, sprintf(getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), 'order'));
	return;
}

// Add description as navigation point
ADD_DESCR('member', __FILE__);

$URL = ''; $id = 0;
$whereStatement = " WHERE `visible`='Y'";

// Set undefined array elements
if (!REQUEST_ISSET_GET('msg'))       REQUEST_SET_GET('msg'      , '');
if (!REQUEST_ISSET_POST('zip'))      REQUEST_SET_POST('zip'     , '');
if (!REQUEST_ISSET_POST('html'))     REQUEST_SET_POST('html'    , '');
if (!REQUEST_ISSET_POST('receiver')) REQUEST_SET_POST('receiver', '');
if (IS_ADMIN()) $whereStatement = '';

// Minimum mails / order
define('__MIN_VALUE', getConfig('order_min'));

// Count unconfirmed mails
$links = GET_TOTAL_DATA(getUserId(), "user_links", "id", 'userid', true);

// Does the user has more than 0 mails per day set?
$HOLIDAY = 'userid';
if (GET_EXT_VERSION('holiday') >= '0.1.3') {
	// Fetch also holiday activation data
	$HOLIDAY = "holiday_active";
} // END - if

$result_mmails = SQL_QUERY_ESC("SELECT userid, receive_mails, mail_orders, ".$HOLIDAY."
FROM `{!_MYSQL_PREFIX!}_user_data`
WHERE userid=%s AND max_mails > 0 LIMIT 1",
	array(getUserId()), __FILE__, __LINE__);

$mmails = SQL_NUMROWS($result_mmails);
list($DMY, $MAXI, $ORDERS, $HOLIDAY) = SQL_FETCHROW($result_mmails);
SQL_FREERESULT($result_mmails);
if ($HOLIDAY == $DMY) $HOLIDAY='N';

$ALLOWED = $MAXI - $ORDERS;
if (getConfig('order_max_full') == 'MAX') $ALLOWED = $MAXI;

// Now check his points amount
$total = GET_TOTAL_DATA(getUserId(), "user_points", "points") - GET_TOTAL_DATA(getUserId(), "user_data", "used_points");;

if (($HOLIDAY == 'Y') && (GET_EXT_VERSION('holiday') >= '0.1.3')) {
	// Holiday is active!
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('HOLIDAY_ORDER_NOT_POSSIBLE'));
} elseif ((REQUEST_ISSET_POST(('frametester'))) && ($ALLOWED > 0) && (REQUEST_POST('receiver') > 0)) {
	// Continue with the frametester, we first need to store the data temporary in the pool
	//
	// First we would like to store the data and get it's pool position back...
	$result = SQL_QUERY_ESC("SELECT id, data_type
FROM `{!_MYSQL_PREFIX!}_pool`
WHERE sender=%s AND url='%s' AND timestamp > (UNIX_TIMESTAMP() - %s) LIMIT 1",
		array(getUserId(), REQUEST_POST('url'), getConfig('url_tlock')), __FILE__, __LINE__);

	$type = "TEMP"; $id = 0;
	if (SQL_NUMROWS($result) == 1) {
		// Load id and mail type
		list($id, $type) = SQL_FETCHROW($result);
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	if ($type == "TEMP") {
		// No entry found, so we need to check out the stats table as well... :)
		// We have to add that suff here, now we continue WITHOUT checking and check the text and subject against some filters
		$URL = '';
		if (getConfig('test_text') == 'Y') {
			// Test submitted text against some filters (length, URLs in text etc.)
			if ((strpos(strtolower(REQUEST_POST('text')), "https://") > -1) || (strpos(strtolower(REQUEST_POST('text')), "http://") > -1) || (strpos(strtolower(REQUEST_POST('text')), "www") > -1)) {
				// URL found!
				$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('URL_FOUND');
			} // END - if

			// Remove new-line and carriage-return characters
			$TEST = str_replace("\n", '', str_replace("\r", '', REQUEST_POST('text')));

			// Text length within allowed length?
			if (strlen($TEST) > getConfig('max_tlength')) {
				// Text is too long!
				$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('OVERLENGTH');
			} // END - if
		} // END - if

		// Shall I test the subject line against URLs?
		if (getConfig('test_subj') == 'Y') {
			// Check the subject line for issues
			REQUEST_SET_POST('subject', str_replace("\\", "[nl]", substr(REQUEST_POST('subject'), 0, 200)));
			if ((strpos(strtolower(REQUEST_POST('subject')), "http://") > -1) || (strpos(strtolower(REQUEST_POST('subject')), "www") > -1)) {
				// URL in subject found
				$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('SUBJ_URL');
			} // END - if
		} // END - if

		// And shall I check that his URL is not in the black list?
		if (getConfig('url_blacklist') == 'Y') {
			// Ok, I do that for you know...
			$result = SQL_QUERY_ESC("SELECT UNIX_TIMESTAMP(`timestamp`) AS tstamp FROM `{!_MYSQL_PREFIX!}_url_blacklist` WHERE `url`='%s' LIMIT 1",
				array(REQUEST_POST('url')), __FILE__, __LINE__);

			if (SQL_NUMROWS($result) == 1) {
				// Jupp, we got one listed
				list($blist) = SQL_FETCHROW($result);

				// Create redirect-URL
				$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('BLIST_URL')."&amp;blist=".$blist;
			} // END - if

			// Free result
			SQL_FREERESULT($result);
		} // END - if

		// Enougth receivers entered?
		if ((REQUEST_POST('receiver') < getConfig('order_min')) && (!IS_ADMIN())) {
			// Less than allowed receivers entered!
			$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('MORE_RECEIVERS3');
		} // END - if

		// Validate URL
		if (!isUrlValid(REQUEST_POST('url'))) {
			// URL is invalid!
			$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('INVALID_URL');
		} // END - if

		// Probe for HTML extension
		if (EXT_IS_ACTIVE('html_mail')) {
			// HTML or regular text mail?
			if (REQUEST_POST('html') == 'Y') {
				// Chek for valid HTML tags
				REQUEST_SET_POST('text', HTML_CHECK_TAGS(REQUEST_POST('text')));

				// Maybe invalid tags found?
				if (!REQUEST_ISSET_POST(('text'))) $URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('INVALID_TAGS')."&amp;id=".$id;
			} else {
				// Remove any HTML code
				REQUEST_SET_POST('text', str_replace("<", "{OPEN_HTML}", str_replace(">", "{CLOSE_HTML}", REQUEST_POST('text'))));
			}
		}
	} elseif (!IS_ADMIN()) {
		// He has already sent a mail within a specific time
		$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('URL_TLOCK')."&amp;id=".$id;
	}

	// Still no error?
	if (empty($URL)) {
		// Check if category and number of receivers is okay
		$add = '';
		if ((getConfig('order_multi_page') == 'Y') && (REQUEST_ISSET_POST('zip'))) {
			// Choose recipients by ZIP code
			$add = " AND d.zip LIKE '".bigintval(REQUEST_POST('zip'))."{PER}'";
		} // END - if

		// Check for userids
		$result = SQL_QUERY_ESC("SELECT DISTINCT c.userid FROM `{!_MYSQL_PREFIX!}_user_cats` AS c
LEFT JOIN `{!_MYSQL_PREFIX!}_user_data` AS d
ON c.userid=d.userid
WHERE c.cat_id=%s AND c.userid != '%s' AND d.`status`='CONFIRMED' AND d.receive_mails > 0".$add."
ORDER BY d.%s %s",
 array(
 	bigintval(REQUEST_POST('cat')),
	getUserId(),
	getConfig('order_select'),
	getConfig('order_mode'),
 ), __FILE__, __LINE__);

		// Do we enougth receivers left?
		if (SQL_NUMROWS($result) >= REQUEST_POST('receiver')) {
			// Check for holiday extensions
			$HOLIDAY = false;
			if (GET_EXT_VERSION('holiday') >= '0.1.3') {
				// Include checking for users in holiday
				$HOLIDAY = true;
			} // END - if

			// Load receivers from database
			$TEST = array(); $cnt = 0;
			while ($content = SQL_FETCHARRAY($result)) {
				if ($HOLIDAY) {
					// Check for his holiday status
					$result_holiday = SQL_QUERY_ESC("SELECT `id` FROM `{!_MYSQL_PREFIX!}_user_holidays`
WHERE userid=%s AND holiday_start < UNIX_TIMESTAMP() AND holiday_end > UNIX_TIMESTAMP() LIMIT 1",
 array(bigintval($content['userid'])), __FILE__, __LINE__);
 					if (SQL_NUMROWS($result_holiday) == 1) $content['userid'] = 0; // Exclude user who are in holiday

					// Free memory
					SQL_FREERESULT($result_holiday);
				} // END - if

				if ($content['userid'] > 0) {
					// Add receiver
					$TEST[] = $content['userid'];
					$cnt++;
				} // END - if
			} // END - while

			// Free memory
			SQL_FREERESULT($result);

			// Implode array into string for the sending pool
			$RECEIVER = implode($TEST, ';');

			// Count array for maximum sent
			$MAX_SEND = count($TEST);

			// Update receiver list
			SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET receive_mails=receive_mails-1 WHERE userid IN (%s) LIMIT %s",
				array(str_replace(';', ", ", $RECEIVER), $MAX_SEND), __FILE__, __LINE__);

			// Is calculated max receivers larger than wanted receivers then reset it
			if ($MAX_SEND > REQUEST_POST('receiver')) $MAX_SEND = REQUEST_POST('receiver');

			// Calculate used points
			$USED = $MAX_SEND * getPaymentPoints(bigintval(REQUEST_POST('type')));

			// Fix empty zip code
			if (!REQUEST_ISSET_POST('zip')) REQUEST_SET_POST('zip', '0');

			// Check if he has enougth points for this order and selected more than 0 receivers
			if (($USED > 0) && ($USED <= $total) && ($MAX_SEND > 0)) {
				// Gettings points is okay, so we can add $USED later from
				$TIME = time();
				if (($id == '0') || ($type != "TEMP")) {
					// New order
					$id = 0;
					if (EXT_IS_ACTIVE('html_mail')) {
						// HTML extension is active
						SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_pool` (sender, subject, text, receivers, payment_id, data_type, timestamp, url, cat_id, target_send, zip, html_msg)
 VALUES ('%s','%s','%s','%s','%s','TEMP','%s','%s','%s','%s','%s','%s')",
array(
	getUserId(),
	REQUEST_POST('subject'),
	REQUEST_POST('text'),
	$RECEIVER,
	bigintval(REQUEST_POST('type')),
	$TIME,
	REQUEST_POST('url'),
	bigintval(REQUEST_POST('cat')),
	$MAX_SEND,
	bigintval(REQUEST_POST('zip')),
	REQUEST_POST('html')
), __FILE__, __LINE__);
					} else {
						// No HTML extension is active
						SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_pool` (sender, subject, text, receivers, payment_id, data_type, timestamp, url, cat_id, target_send, zip)
 VALUES ('%s','%s','%s','%s','%s','TEMP','%s','%s','%s','%s','%s')",
array(
	getUserId(),
	REQUEST_POST('subject'),
	REQUEST_POST('text'),
	$RECEIVER,
	bigintval(REQUEST_POST('type')),
	$TIME,
	REQUEST_POST('url'),
	bigintval(REQUEST_POST('cat')),
	$MAX_SEND,
	bigintval(REQUEST_POST('zip')),
), __FILE__, __LINE__);
					}
				} else {
					// Change current order
					if (EXT_IS_ACTIVE('html_mail')) {
						// HTML extension is active
						SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_pool` SET
subject='%s',
text='%s',
receivers='%s',
payment_id=%s,
timestamp=UNIX_TIMESTAMP(),
url='%s',
cat_id=%s,
target_send=%s,
zip=%s,
html_msg='%s'
WHERE `id`=%s LIMIT 1",
array(
	REQUEST_POST('subject'),
	REQUEST_POST('text'),
	$RECEIVER,
	bigintval(REQUEST_POST('type')),
	REQUEST_POST('url'),
	bigintval(REQUEST_POST('cat')),
	$MAX_SEND,
	bigintval(REQUEST_POST('zip')),
	REQUEST_POST('html'),
	bigintval($id)
), __FILE__, __LINE__);
					} else {
						// No HTML extension is active
						SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_pool` SET
subject='%s',
text='%s',
receivers='%s',
payment_id=%s,
timestamp=UNIX_TIMESTAMP(),
url='%s',
cat_id=%s,
target_send=%s,
zip=%s
WHERE `id`=%s LIMIT 1",
array(
	REQUEST_POST('subject'),
	REQUEST_POST('text'),
	$RECEIVER,
	bigintval(REQUEST_POST('type')),
	REQUEST_POST('url'),
	bigintval(REQUEST_POST('cat')),
	$MAX_SEND,
	bigintval(REQUEST_POST('zip')),
	bigintval($id)
), __FILE__, __LINE__);
					}
				}

				// Do we need to get the ID number?
				if ($id == 0) {
					// Order is placed as temporary. We need to get it's id for the frametester
					$result = SQL_QUERY_ESC("SELECT `id` FROM `{!_MYSQL_PREFIX!}_pool` WHERE sender=%s AND subject='%s' AND payment_id=%s AND data_type='TEMP' AND timestamp=%s LIMIT 1",
					array(
						getUserId(),
						REQUEST_POST('subject'),
						bigintval(REQUEST_POST('type')),
						$TIME
					), __FILE__, __LINE__);

					list($id) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
				}

				// ID is received so we can redirect the user, used points will be added when he send's out the mail
				$URL = 'modules.php?module=frametester&amp;order=' . $id;
			} elseif ($MAX_SEND == 0) {
				// Not enougth receivers found which can receive mails
				$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('MORE_RECEIVERS2');
			} else {
				// No enougth points left!
				$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('MORE_POINTS');
			}
		} else 	{
			// Ordered more mails than he can send in this category
			$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('NO_RECS_LEFT');
		}
	}
} elseif (REQUEST_POST('receiver') == '0') {
	// Not enougth receivers selected
	$URL = 'modules.php?module=login&amp;what=order&amp;msg=' . getCode('MORE_RECEIVERS1');
} elseif (($ALLOWED == 0) && (getConfig('order_max_full') == 'ORDER')) {
	// No more mail orders allowed
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('MEMBER_ORDER_ALLOWED_EXHAUSTED'));
} elseif (($links < getConfig('unconfirmed')) && ($mmails == '1')) {
	// Display order form
	$result_cats = SQL_QUERY("SELECT id, cat FROM `{!_MYSQL_PREFIX!}_cats`".$whereStatement." ORDER BY `sort`", __FILE__, __LINE__);
	if (SQL_NUMROWS($result_cats) > 0) {
		if ($total > 0) {
			// Initialize array...
			$CATS = array(
				'id'   => array(),
				'name' => array(),
				'uids' => array()
			);

			// Enable HTML checking
			// @TODO Rewrite this to a filter
			$HTML = ''; $HOLIDAY = false; $HOL_STRING = '';
			if ((EXT_IS_ACTIVE('html_mail')) && (REQUEST_POST('html') == 'Y')) $HTML = " AND `html`='Y'";
			if (GET_EXT_VERSION('holiday') >= '0.1.3') {
				// Extension's version is fine
				$HOLIDAY = true; $HOL_STRING = " AND `holiday_active`='N'";
			} // END - if

			// ... and begin loading stuff
			while ($content = SQL_FETCHARRAY($result_cats)) {
				$CATS['id'][]   = bigintval($content['id']);
				$CATS['name'][] = $content['cat'];

				// Select users in current category
				$result_uids = SQL_QUERY_ESC("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_cats` WHERE cat_id=%s AND userid != '%s' ORDER BY `userid` ASC",
					array(bigintval($content['id']), getUserId()), __FILE__, __LINE__);

				$uid_cnt = 0;
				while (list($ucat) = SQL_FETCHROW($result_uids)) {
					// Check for holiday system
					$HOL_ACTIVE = false;
					if ($HOLIDAY) {
						// Check user's holiday status
						$result_holiday = SQL_QUERY_ESC("SELECT DISTINCT d.userid FROM `{!_MYSQL_PREFIX!}_user_data` AS d
LEFT JOIN `{!_MYSQL_PREFIX!}_user_holidays` AS h
ON d.userid=h.userid
WHERE d.userid=%s AND d.receive_mails > 0 AND d.`status`='CONFIRMED' AND d.`holiday_active`='Y'
AND h.holiday_start < UNIX_TIMESTAMP() AND h.holiday_end > UNIX_TIMESTAMP()
LIMIT 1", array(bigintval($ucat)), __FILE__, __LINE__);
						if (SQL_NUMROWS($result_holiday) == 1) {
							// Holiday is active!
							$HOL_ACTIVE = true;
						} // END - if

						// Free memory
						SQL_FREERESULT($result_holiday);
					} // END - if

					if (!$HOL_ACTIVE) {
						// Check if the user want's to receive mails?
						$result_ver = SQL_QUERY_ESC("SELECT zip FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s".$HTML." AND receive_mails > 0 AND `status`='CONFIRMED' LIMIT 1",
							array(bigintval($ucat)), __FILE__, __LINE__);

						if ((SQL_NUMROWS($result_ver) == 1) && (REQUEST_ISSET_POST('zip')) && (getConfig('order_multi_page') == 'Y')) {
							list($zip) = SQL_FETCHROW($result_ver);
							SQL_FREERESULT($result_ver);
							if (substr($zip, 0, strlen(REQUEST_POST('zip'))) == REQUEST_POST('zip')) {
								// Ok, ZIP part is found
								$uid_cnt++;
							} // END - if
						} else {
							// Count numbers up!
							$uid_cnt += SQL_NUMROWS($result_ver);
						}
					} // END - if
				} // END - while

				// Free memory
				SQL_FREERESULT($result_uids);
				$CATS['uids'][] = $uid_cnt;
			} // END - while

			// Free memory
			SQL_FREERESULT($result_cats);

			// Now we need to load the mail types...
			$result = SQL_QUERY("SELECT id, price, payment, mail_title FROM `{!_MYSQL_PREFIX!}_payments` ORDER BY payment", __FILE__, __LINE__);

			$typeS = array();
			if (SQL_NUMROWS($result) > 0) {
				// Check for message ID in URL
				$message = '';
				switch (REQUEST_GET('msg'))
				{
				case getCode('URL_TLOCK'):
					$result = SQL_QUERY_ESC("SELECT timestamp FROM `{!_MYSQL_PREFIX!}_pool` WHERE `id`=%s LIMIT 1",
					 array(bigintval(REQUEST_GET('id'))), __FILE__, __LINE__);

					// Load timestamp from last order
					list($LORDER) = SQL_FETCHROW($result);
					$LORDER = generateDateTime($LORDER, "1");

					// Free memory
					SQL_FREERESULT($result);

					// Calculate hours...
					$STD = round(getConfig('url_tlock') / 60 / 60);

					// Minutes...
					$MIN = round((getConfig('url_tlock') - $STD * 60 * 60) / 60);

					// And seconds
					$SEC = getConfig('url_tlock') - $STD * 60 * 60 - $MIN * 60;

					// Finally contruct the message
					// @TODO Rewrite this old lost code to a template
					$message = "{--MEMBER_URL_TIME_LOCK--}<br />{--CONFIG_URL_TLOCK--} ".$STD."
						{--_HOURS--}, ".$MIN." {--_MINUTES--} {--_AND--} ".$SEC." {--_SECONDS--}<br />
						{--MEMBER_LAST_TLOCK--}: ".$LORDER;
					break;

				case getCode('OVERLENGTH'):
					$message = getMessage('MEMBER_TEXT_OVERLENGTH');
					break;

				case getCode('URL_FOUND'):
					$message = getMessage('MEMBER_TEXT_CONTAINS_URL');
					break;

				case getCode('SUBJ_URL'):
					$message = getMessage('MEMBER_SUBJ_CONTAINS_URL');
					break;

				case getCode('BLIST_URL'):
					$message = "{--MEMBER_URL_BLACK_LISTED--}<br />\n{--MEMBER_BLIST_TIME--}: ".generateDateTime(REQUEST_GET('blist'), '0');
					break;

				case getCode('NO_RECS_LEFT'):
					$message = getMessage('MEMBER_SELECTED_MORE_RECS');
					break;

				case getCode('INVALID_TAGS'):
					$message = getMessage('MEMBER_HTML_INVALID_TAGS');
					break;

				case getCode('MORE_POINTS'):
					$message = getMessage('MEMBER_MORE_POINTS_NEEDED');
					break;

				case getCode('MORE_RECEIVERS1'):
					$message = getMessage('MEMBER_ENTER_MORE_RECEIVERS');
					break;

				case getCode('MORE_RECEIVERS2'):
					$message = getMessage('MEMBER_NO_MORE_RECEIVERS_FOUND');
					break;

				case getCode('MORE_RECEIVERS3'):
					$message = sprintf(getMessage('MEMBER_ENTER_MORE_MIN_RECEIVERS'), getConfig('order_min'));
					break;

				case getCode('INVALID_URL'):
					$message = getMessage('MEMBER_ENTER_INVALID_URL');
					break;

				case "": // When no error code is included in the URL we do not need to output an error message as well...
					break;

				default:
					DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown error code %s detected.", REQUEST_GET('msg')));
					$message = sprintf(getMessage('UNKNOWN_CODE'), REQUEST_GET('msg'));
					break;
				}

				if (!empty($message)) {
					// We got system message so we drop it out to the user
					LOAD_TEMPLATE('admin_settings_saved', false, $message);
				} // END - if

				// Load all email types...
				while ($typeS[] = SQL_FETCHROW($result)) {
					// Nothing to do here... ;-)
				} // END - while

				// Free memory
				SQL_FREERESULT($result);

				// Output user's points
				$total = translateComma($total);

				// Check how many mail orders he has placed today and how many he's allowed to send
				switch (getConfig('order_max_full'))
				{
				case 'MAX': // He is allowed to send as much as possible
					define('ORDER_MAX_VALUE', getMessage('MEMBER_ORDER_ALLOWED_MAX'));
					break;

				case 'ORDER': // He is allowed to send as much as he setup the receiving value
					define('ORDER_MAX_VALUE', sprintf(getMessage('MEMBER_ORDER_ALLOWED_RECEIVE'), $ALLOWED, $MAXI));
					break;

				default: // Unknown/invalid
					DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown order_mas_full config detected.", getConfig('order_max_full')));
					define('ORDER_MAX_VALUE', getMessage('MEMBER_ORDER_ALLOWED_UNKNOWN'));
					break;
				}

				// Load final template
				LOAD_TEMPLATE("member_order_points", false, $total);

				// Reset variables
				$OLD_ORDER = false; $subject = ''; $text = ''; $target = '';

				// Check if we already have an order placed and make it editable
				$result = SQL_QUERY_ESC("SELECT subject, text, payment_id, timestamp, url, target_send, cat_id, zip FROM `{!_MYSQL_PREFIX!}_pool` WHERE sender=%s AND data_type='TEMP' LIMIT 1",
				 array(getUserId()), __FILE__, __LINE__);

				if (SQL_NUMROWS($result) == 1) {
					// Old order found
					list($subject, $text, $payment, $tstamp, $url, $target, $content['cat'], $zip) = SQL_FETCHROW($result);

					// Fix max receivers when it is too much
					if ((isset($CATS['uids'][$content['cat']])) && ($target > $CATS['uids'][$content['cat']])) $target = $CATS['uids'][$content['cat']];

					// Old order is grabbed
					$OLD_ORDER = true;
				} else {
					// Default output for that your members don't forget it...
					$url = "http://";
				}

				// Free result
				SQL_FREERESULT($result);

				if ((REQUEST_ISSET_POST(('data'))) || ((getConfig('order_multi_page') != 'Y') && ((!IS_ADMIN()) && (!EXT_IS_ACTIVE('html_mail'))))) {
					// Pre-output categories
					$CAT = '';
					foreach ($CATS['id'] as $key => $value) {
						$CAT .= "      <option value=\"".$value."\"";
						if (($OLD_ORDER) && ($content['cat'] == $value)) $CAT .= ' selected="selected"';
						$CAT .= ">".$CATS['name'][$key]." (".$CATS['uids'][$key]." {--USER_IN_CAT--})</option>\n";
					} // END - foreach

					// Mail type
					$type = '';
					foreach ($typeS as $key => $value) {
						$P = translateComma($typeS[$key][1]);
						if (is_array($value)) {
							// Output option line
							$type .= "      <option value=\"".$typeS[$key][0]."\"";
							if (($OLD_ORDER) && ($payment == $typeS[$key][0])) $type .= ' selected="selected"';
							$type .= ">".$P." {--PER_MAIL--} - ".$typeS[$key][3]." - ".round($typeS[$key][2])." {--PAYMENT--}</option>\n";
						} // END - if
					} // END - foreach

					// Put all in constants for the template
					define('CATEGORY_SELECTION', $CAT);
					define('TYPE_SELECTION', $type);
					define('TARGET', $target);
					define('SUBJECT', $subject);
					define('TEXT', COMPILE_CODE($text));
					define('T_URL', $url);

					if (REQUEST_ISSET_POST('zip')) {
						// Output entered ZIP code
						define('ZIP_OUTPUT', LOAD_TEMPLATE("member_order-zip2", true, REQUEST_POST('zip')));
					} else {
						define('ZIP_OUTPUT', "<tr><td colspan=\"5\" height=\"5\" class=\"seperator\">&nbsp;</td></tr>");
					}

					// HTML extension
					if ((EXT_IS_ACTIVE('html_mail')) && (REQUEST_POST('html') == 'Y')) {
						// Extension is active so output valid HTML tags
						define('MEMBER_HTML_EXTENSION', LOAD_TEMPLATE("member_order-html_ext", true, HTML_ADD_VALID_TAGS()));
					} else {
						// Extension not active and/or class not uploaded
						define('MEMBER_HTML_EXTENSION', "<tr><td colspan=\"5\"><input type=\"hidden\" name=\"html\" value=\"N\"> /</td></tr>");
					}

					// Output form for page 2
					LOAD_TEMPLATE("member_order_page2");
				} else {
					// Remember maybe entered ZIP code in constant
					$add = '';
					if (EXT_IS_ACTIVE('html_mail')) {
						// Add some content when html extension is active
						if ((getConfig('order_multi_page') == 'Y') || (IS_ADMIN())) $add = "<tr><td colspan=\"2\" class=\"seperator bottom2\" height=\"5\">&nbsp;</td></tr>\n";
						define('MEMBER_HTML_EXTENSION', LOAD_TEMPLATE("member_order-html_intro", true));
					} else {
						// No HTML extension installed
						define('MEMBER_HTML_EXTENSION', "<tr><td colspan=\"2\"><input type=\"hidden\" name=\"html\" value=\"N\" /></td></tr>");
					}

					// Do we want ZIP code or not?
					if ((getConfig('order_multi_page') == 'Y') || (IS_ADMIN())) {
						// Yes
						if (REQUEST_POST('zip') > 0) {
							$content = array(
								'zip' => bigintval(REQUEST_POST('zip')),
								'add' => $add
							);
						} else {
							$content = array(
								'zip' => "",
								'add' => $add
							);
						}
						define('MEMBER_ZIP_CONTENT', LOAD_TEMPLATE("member_order-zip1", true, $content));
					} else {
						// No
						define('MEMBER_ZIP_CONTENT', '');
					}

					// Output form for page 1 (ZIP code or HTML)
					LOAD_TEMPLATE("member_order_page1");
				}
			} else {
				// No mail types defined
				LOAD_TEMPLATE('admin_settings_saved', false, "<span class=\"member_failed\">{--MEMBER_NO_PAYMENTS--}</span>");
			}
		} else {
			// No points left
			LOAD_TEMPLATE('admin_settings_saved', false, "<span class=\"member_failed\">{--MEMBER_NO_POINTS--}</span>");
		}
	} else {
		// No cateogries are defined yet
		LOAD_TEMPLATE('admin_settings_saved', false, "<span class=\"member_failed\">{--MEMBER_NO_CATS--}</span>");
	}
} elseif ($mmails == '0') {
	// Please set more than 0 mails per day
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('MEMBER_HAS_ZERO_MMAILS'));
} else {
	// Please confirm some mails first
	LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('MEMBER_LINKS_LEFT'), $links, getConfig('unconfirmed')));
}

if (!empty($URL)) {
	// Redirect to requested URL
	redirectToUrl($URL);
} // END - if

//
?>
