<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/05/2008 *
 * ===============                              Last change: 09/05/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : surfbar.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : The surfbar itself                               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Die Surfbar selbst                               *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here (Oh, I hope this is not unsecure? Am I paranoia??? ;-) )
require('inc/libs/security_functions.php');

// Init "action" and "what"
$GLOBALS['cache_array']['surfbar'] = array();
$GLOBALS['startTime'] = microtime(true);
$GLOBALS['what'] = '';
$GLOBALS['action'] = '';

// Set module
$GLOBALS['module'] = 'surfbar';
$GLOBALS['refid']  = 0;
$GLOBALS['output_mode'] = 0;
$msg = null;

// Load the required file(s)
require('inc/config.php');

// Is the script installed?
if (isInstalled()) {
	// Only logged in users may use this surfbar!
	REDIRECT_ON_UNINSTALLED_EXTENSION('surfbar');

	// No member?
	if (!IS_MEMBER()) {
		// Redirect
		// @TODO Display quick login form here or redirect as configured
		redirectToUrl('modules.php?module=index');
	} // END - if

	// Handle tasks on self-maintenance
	SURFBAR_HANDLE_SELF_MAINTENANCE();

	// Is there a check value?
	if ((SURFBAR_CHECK_RELOAD_FULL()) || ((REQUEST_ISSET_GET(('frame'))) && (in_array(REQUEST_GET('frame'), array('stop', 'stop2', 'stats', 'textlinks'))))) {
		// Reload-lock is full, surfbar stopped so...
		// Load header
		loadIncludeOnce('inc/header.php');

		// Load template
		if (((REQUEST_ISSET_GET(('frame'))) && (REQUEST_GET('frame') == 'stop')) || (!REQUEST_ISSET_GET(('frame')))) {
			// Load template for "start" page
			LOAD_TEMPLATE('surfbar_frame_start');

			// Load banner
			LOAD_TEMPLATE('surfbar_start_banner');

			// This makes the footer appear again
			REQUEST_UNSET_GET(('frame'));
		} elseif ((REQUEST_ISSET_GET(('frame'))) && (REQUEST_GET('frame') == 'stats')) {
			// Get total points amount
			$points = GET_TOTAL_DATA(getUserId(), 'user_points', 'points') - GET_TOTAL_DATA(getUserId(), 'user_data', 'used_points');

			// Prepare content
			$content = array(
				'points'   => translateComma($points),
				'online'   => SURFBAR_DETERMINE_TOTAL_ONLINE(),
				'reload'   => (getConfig('surfbar_stats_reload') * 1000),
				'c_total'  => translateComma(getConfig('surfbar_total_counter')),
				'c_today'  => translateComma(getConfig('surfbar_daily_counter')),
				'c_yester' => translateComma(getConfig('surfbar_yester_counter')),
				'c_week'   => translateComma(getConfig('surfbar_weekly_counter')),
				'c_month'  => translateComma(getConfig('surfbar_monthly_counter')),
			);

			// Load template for "stats" page
			LOAD_TEMPLATE('surfbar_frame_stats', false, $content);
		} elseif ((REQUEST_ISSET_GET(('frame'))) && (REQUEST_GET('frame') == 'textlinks')) {
			// Prepare content
			$content = array(
				'online'   => SURFBAR_DETERMINE_TOTAL_ONLINE(),
				'reload'   => (getConfig('surfbar_stats_reload') * 1000)
			);

			// Load template for "stats" page
			LOAD_TEMPLATE('surfbar_frame_textlinks', false, $content);
		} else {
			// Prepare content
			$content = array(
				'restart'   => getConfig('surfbar_restart_time'),
				'start'     => str_repeat('X', strlen(getConfig('surfbar_restart_time'))),
				'autostart' => (getConfig('surfbar_autostart') == 'Y') ? 'true' : 'false'
			);

			// Load template for stopped surfbar
			LOAD_TEMPLATE('surfbar_stopped', false, $content);
		}
	} elseif ((REQUEST_ISSET_GET(('check'))) && (REQUEST_ISSET_GET('id')) && (REQUEST_ISSET_GET(('salt')))) {
		// Dummy next id get
		SURFBAR_DETERMINE_NEXT_ID(REQUEST_GET('id'));

		// Check reload lock and validation code
		if ((!SURFBAR_CHECK_RELOAD_LOCK(REQUEST_GET('id'))) && (SURFBAR_CHECK_VALIDATION_CODE(REQUEST_GET('id'), REQUEST_GET('check'), REQUEST_GET('salt')))) {
			// Lock the URL (id) down
			SURFBAR_LOCKDOWN_ID(REQUEST_GET('id'));

			// Code is valid so pay points here
			SURFBAR_PAY_POINTS();

			// Check if reload is full
			if (SURFBAR_CHECK_RELOAD_FULL()) {
				// Then load waiting page
				SURFBAR_RELOAD_TO_STOP_PAGE();
			} // END - if
		} else {
			// Reload to stop frame!
			SURFBAR_RELOAD_TO_STOP_PAGE();
		}

		// All done, so fix notice for footer.php
		$GLOBALS['footer_sent'] = 1;
	} else {
		// Prepare content
		$content = '';

		// Determine template name
		$templateName = SURFBAR_DETERMINE_TEMPLATE_NAME();

		// Frame "top" set?
		if ((REQUEST_ISSET_GET(('frame'))) && (REQUEST_GET('frame') == 'top')) {
			// Determine next id
			$nextId = SURFBAR_DETERMINE_NEXT_ID();

			// Is there a valid id?
			if ($nextId > 0) {
				// Then prepare other content
				$content = array(
					'id'          => $nextId,
					'check'       => SURFBAR_GENERATE_VALIDATION_CODE($nextId),
					'salt'        => SURFBAR_GET_SALT(),
					'reward'      => translateComma(SURFBAR_GET_REWARD($nextId)),
					'url'         => SURFBAR_GET_URL($nextId),
					'curr_reload' => SURFBAR_GET_USER_LOCKS(),
					'max_urls'    => SURFBAR_GET_TOTAL_URLS(),
					'reload'      => SURFBAR_GET_RELOAD_TIME($nextId),
					'xxx'         => str_repeat('X', strlen(SURFBAR_GET_RELOAD_TIME($nextId)))
				);

				// Update salt (double-call lock!) and statistics
				SURFBAR_UPDATE_SALT_STATS();
			} else {
				// Load new URL
				SURFBAR_RELOAD_TO_STOP_PAGE('stop2');
			}
		} elseif ((REQUEST_ISSET_GET(('frame'))) && (REQUEST_GET('frame') == 'start')) {
			// Starter frame found so let the footer display
			REQUEST_UNSET_GET(('frame'));
		} else {
			// Load header in frameset mode
			$isFrameset = true;
		}

		// Load header
		loadIncludeOnce('inc/header.php');

		// Load that template
		//* DEBUG: */ die("templateName={$templateName}<br />\n<strong>content</strong>=<pre>".print_r($content, true)."</pre>");
		LOAD_TEMPLATE($templateName, false, $content);
	}

	// Load footer
	loadIncludeOnce('inc/footer.php');
} else {
	// You have to install first!
	redirectToUrl('install.php');
}

// Really all done here... ;-)
shutdown();

//
?>
